#include <stdio.h>
#include <strings.h>

#define BAD_FILE 1
#define SYNTAX	2

char	*MoveUp(char *, int);
char	*CutOff(char *,int);

void main(argc,argv)
int argc;
char *argv[];

{
	FILE	*TheFile;
	int	newpos;
	char	line[255];
	char	FinalLine[255];
	char	*newline;
	char	*TheEnd;
	int	StartKeep=0;
	int	EndKeep=0;
	char	*FileName;

	line[0]='\0';
	FileName=NULL;

	while (--argc) {
		if (*argv[argc] == '-')
			StartKeep= -atoi(argv[argc]);
		else if (*argv[argc] == '+')
			EndKeep= atoi(argv[argc]);
		else FileName=argv[argc];
	}

	if ((!StartKeep && !EndKeep)) {
		ErrorOut(SYNTAX,"No Message");
		exit(0);
	}

	if (!FileName) {
		TheFile=stdin;
	} else if (!(TheFile=fopen(FileName,"r"))) {
		ErrorOut(BAD_FILE,FileName);
		exit(0);
	}

	while (!feof(TheFile)) {

		GetLine(TheFile,line);
		FinalLine[0]='\0';
		if (StartKeep) {
			strcpy(FinalLine,line);
			CutOff(FinalLine,StartKeep);
		}
		if (EndKeep) {
			if (StartKeep>EndKeep) {
				newline=MoveUp(FinalLine,EndKeep);
				strcpy(FinalLine,newline);
			} else {
				newline=MoveUp(line,EndKeep);
				TheEnd=strchr(FinalLine,0);
				TheEnd--;
				if (*TheEnd == '\n')
					*TheEnd = '\0'; 

				strcat(FinalLine,newline);
			}
		}
		printf("%s",FinalLine);
	}

}

GetLine(TheInput,TheLine)
FILE	*TheInput;
char	*TheLine;

{
	*TheLine=fgetc(TheInput);
	while (*TheLine != '\n' && !feof(TheInput)) {
		TheLine++;
		*TheLine=fgetc(TheInput);
	}
	TheLine++;
	*TheLine='\0';
	
	return;
}

char	*MoveUp(TheLine,TheMove)
char	*TheLine;
int	TheMove;
{
	int	i;

	for (i=TheMove; *TheLine!='\0' && *TheLine!='\n' && i>0; i--) {
		TheLine++;
	}

	return TheLine;
}

char	*CutOff(TheLine,TheCutOff)
char	*TheLine;
int	TheCutOff;
{
	int	i;
	char	*TheEnd;

	TheEnd=TheLine;
	for (i=TheCutOff; *TheEnd!='\0' && *TheEnd!='\n' && i>0; i--) {
		TheEnd++;
	}
	*TheEnd++ = '\n';
	*TheEnd='\0';
	return TheLine;
}

ErrorOut(Why,Message)
int	Why;
char	*Message;
{
	printf ("Syntax: astrip +/-number [-/+number] [filename]\n");
	if (Why==BAD_FILE)
		printf("	Could not get file >%s<.\n",Message);
	else if (Why==SYNTAX) {
		printf("	If no filename is given, astrip uses standard input.\n");
		printf("	If +number is used, all characters after column 'number' are kept.\n");
		printf("		All others are discarded.\n");
		printf("	If -number is used, all characters before column 'number' are kept.\n");
		printf("	If -number +number is used, and -number is greater than +number,\n");
		printf("		the columns between +number and -number are kept.\n");
		printf("	If -number is less than +number, the columns between -number\n");
		printf("		and +number are discarded.\n");
	}
}
